using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;

/// @author Omanimi
/// @version 06.11.2023
/// <summary>
/// 
/// </summary>
public class Rekursio
{
    /// <summary>
    /// 
    /// </summary>
    public static void Main()
    {
        long tulos = Kertoma(4);  // 52! = 8 10¨68
        // long tulosf = KertomaFor(4);
        System.Console.WriteLine(tulos);
    }


    /// <example>
    /// <pre name="test">
    ///   Kertoma(0) === 1L;
    ///   Kertoma(1) === 1L;
    ///   Kertoma(2) === 2L;
    ///   Kertoma(5) === 120L;
    ///   Kertoma(6) === 720L;
    /// </pre>
    /// </example>
    public static long Kertoma(long n)
    {
        if (n <= 1L) return 1L;
        return n * Kertoma(n - 1);
    }
    
    
    /// <example>
    /// <pre name="test">
    ///   KertomaFor(0) === 1L;
    ///   KertomaFor(1) === 1L;
    ///   KertomaFor(2) === 2L;
    ///   KertomaFor(5) === 120L;
    ///   KertomaFor(6) === 720L;
    /// </pre>
    /// </example>
    public static long KertomaFor(long n)
    {
        long tulos = 1L;
        for (int i = 1; i <= n; i++) tulos *= i;
        return tulos;
    }    
    
}